function Catfish(div)
{

	this.div = div;
	this.isOpen = false;

	this.slidesSpeed = 1250;
	this.openSpeed = 100;
	this.closeSpeed = 100;

	this.closedHeight = 80;
	this.openHeight = 300;

	this.numSlides = document.getElementsByClassName('catfishSlide').length;
	this.currentSlide = 0;
	this.slideTimer = null;


	this.init = function()
	{
		eyeBuild.initialize();

		this.addCSSLink();
		this.initButtons();

		this.startSlides();
	}



	this.addCSSLink = function()
	{
		var css = document.createElement('link');
		css.rel = "stylesheet";
		css.type = 'text/css';
		css.href = 'styles/catfish.css';
		document.head.appendChild(css);
	}


	this.addGameiFrame = function()
	{
		if ($('.open .theGame').length < 1)
		{
			var gameDomain = function(url)
				{	var link = document.createElement('a');
					link.setAttribute('href', url);
					return link.protocol + '//' + link.hostname;
				}(GAME_URL);

			var gameDiv = document.createElement('div');
			gameDiv.className = 'theGame';
			this.div.getElementsByClassName('open')[0].appendChild(gameDiv);

			var iframe = document.createElement('iframe');
			// iframe.scrolling = 'no';
			// iframe.horizontalScrolling  = 'no';
			// iframe.verticalscrolling = 'no';
			iframe.id = 'gameiFrame';
			iframe.src = GAME_URL;
			iframe.onload = function(evt) { 
				// console.log(window.frames['gameiFrame'].getElementById('gameContainer'));
				// var gameContainer = window.frames['gameiFrame'].document.getElementById('gameContainer');
				// var gameContainer = iframe.contentWindow.document.getElementById('gameContainer');
				// $(gameContainer).addClass('catfish');
				// iframe.contentWindow.focus();
				iframe.contentWindow.postMessage('initCatfish', gameDomain);
			};
			gameDiv.appendChild(iframe);
			$('#gameiFrame').attr('scrolling', 'no');
			$('#gameiFrame').attr('horizontalscrolling', 'no');
			$('#gameiFrame').attr('verticalscrolling', 'no');

			gameDiv.addEventListener('click', function(evt) { iframe.contentWindow.focus(); });
		}
	}



	this.initButtons = function()
	{
		var self = this;
		$('#nerfCatfish .closed').on('click', function() {
									eyeBuild.doOpen();
									self.open();
								});
		$('#nerfCatfish .closeBtn').on('click', function(evt) {
									evt.stopPropagation();
									eyeBuild.doClose();
									// self.startSlides();
									self.fullClose();
								});
		$('#nerfCatfish .open .focusBtn').on('click', function(evt) {
									// $('#gameiFrame')[0].contentWindow.focus();
									eyeBuild.doClick(0);
								});
	}



	this.startSlides = function()
	{
		this.close();
		this.currentSlide = 0;
		this.nextSlide();
	}


	this.nextSlide = function()
	{
		this.currentSlide++;
		if (this.currentSlide > this.numSlides)
		{	this.currentSlide = this.numSlides;
			return;
		}

		$('.catfishSlide').removeClass('currentSlide');
		$('.slide-' + this.currentSlide).addClass('currentSlide');

		var self = this;
		this.slideTimer = setTimeout(function() { self.nextSlide(); }, self.slidesSpeed);
	}



	this.close = function()
	{
		this.isOpen = false;
		$(this.div).animate( {   height : this.closedHeight }, this.closeSpeed, null, function() {
					$('#nerfCatfish .closed').show();
					$('#nerfCatfish .open').hide();
					$('#nerfCatfish .open .theGame').remove();
				});
	}

	this.fullClose = function()
	{
		this.isOpen = false;
		$(this.div).animate( {   height : 0 }, this.closeSpeed, null, function() {
					$('#nerfCatfish .closed').hide();
					$('#nerfCatfish .open').hide();
					$('#nerfCatfish .open .theGame').remove();
				});
	}

	this.open = function()
	{
		this.isOpen = true;
		clearTimeout(this.slideTimer);

		this.addGameiFrame();

		$(this.div).animate( {   height : this.openHeight }, this.openSpeed);
		$('#nerfCatfish .closed').hide();
		$('#nerfCatfish .open').show();
	}



	this.init();
}
